
:RETRY
@echo off
@set command=e
@set DEVICE_PID=0000
@set DONGLE_PID=0000
@set DEVICE_USAGE_PAGE=0000
@set DONGLE_USAGE_PAGE=0000

for /f "tokens=1,2 delims==" %%a in (config.ini) do (
	if %%a==device_usb_pid set dev_pid=%%b
	if %%a==device_usage_page set dev_usage_page=%%b
	if %%a==unify_dongle_pid set dng_pid=%%b
	if %%a==unify_dongle_usage_page set dng_usage_page=%%b
)

@if "%dev_pid%" EQU "" (
	@echo device_usb_pid NOT DEFINED
	@goto EXIT
)
@if "%dev_usage_page%" EQU "" (
	@echo device_usage_page NOT DEFINED
	@goto EXIT
)
@if "%dng_pid%" EQU "" (
	@echo dongle_pid NOT DEFINED
	@goto EXIT
)
@if "%dng_usage_page%" EQU "" (
	@echo dongle_usage_page NOT DEFINED
	@goto EXIT
)

@if "%dev_pid%" NEQ "%DEVICE_PID%" (set DEVICE_PID=%dev_pid%)
@if "%dev_usage_page%" NEQ "%DEVICE_USAGE_PAGE%" (set DEVICE_USAGE_PAGE=%dev_usage_page%)
@if "%dng_pid%" NEQ "%DONGLE_PID%" (set DONGLE_PID=%dng_pid%)
@if "%dng_usage_page%" NEQ "%DONGLE_USAGE_PAGE%" (set DONGLE_USAGE_PAGE=%dng_usage_page%)

@echo DEVICE_PID : %DEVICE_PID%
@echo DEVICE_USAGE_PAGE : %DEVICE_USAGE_PAGE%
@echo DONGLE_PID : %DONGLE_PID%
@echo DONGLE_USAGE_PAGE : %DONGLE_USAGE_PAGE%


@set DEVICE_NAME=keyboard


:AUTO_PAIRING
@echo --------------------- Factory Mode - Enable Factory Mode ----------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    00    D3 A5    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Enable %DEVICE_NAME% Factory Mode.


REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    00    D3 A5    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Enable Dongle Factory Mode.


@echo --------------------- Factory Mode - Enable Pairing Mode ---------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    20    07 00    45  4E  5F  50  41  49  52
@echo  -Enable %DEVICE_NAME% Pairing Mode.


@echo --------------------- Factory Mode - Enable Pairing Mode ---------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    20    07 00    45  4E  5F  50  41  49  52
@echo  -Enable Dongle Pairing Mode.

::@echo --------------------- Factory Mode - Read Before Pairing data -----------------
::REM               PID                        | CMD | Key | Index  | Data...
::usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%     FA    05    02 00    00  > temp.txt
::@type temp.txt | findstr /n /c:"hid read" || goto ERROR
::@type temp.txt | findstr /n /c:"hid read" > mouse_before_pairing_info.txt
::@del temp.txt
::@echo  -Read Before %DEVICE_NAME% pairing data.


@echo --------------------- Factory Mode - Clear pairing data -----------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    20    00 00    01  43  4C  45  41  52
@echo  -Clear %DEVICE_NAME% pairing data.


REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    20    00 00    01  43  4C  45  41  52
@echo  -Clear Dongle pairing data.


@echo --------------------- Factory Mode - Get Serial Number ---------------------
REM                   PID                           | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    0E    01 00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto ERROR
@type temp.txt | findstr /n /c:"hid read" > temp2.txt
@del temp.txt
@set /p res=<temp2.txt && del temp2.txt

@for /f "tokens=8,8 delims=, " %%a in ("%res%") do (
   @set data0=%%a
)
@for /f "tokens=9,9 delims=, " %%a in ("%res%") do (
   @set data1=%%a
)
@for /f "tokens=10,10 delims=, " %%a in ("%res%") do (
   @set data2=%%a
)
@for /f "tokens=11,11 delims=, " %%a in ("%res%") do (
   @set data3=%%a
)
@for /f "tokens=12,12 delims=, " %%a in ("%res%") do (
   @set data4=%%a
)
@for /f "tokens=13,13 delims=, " %%a in ("%res%") do (
   @set data5=%%a
)
@for /f "tokens=14,14 delims=, " %%a in ("%res%") do (
   @set data6=%%a
)
@for /f "tokens=15,15 delims=, " %%a in ("%res%") do (
   @set data7=%%a
)
@for /f "tokens=16,16 delims=, " %%a in ("%res%") do (
   @set data8=%%a
)
@for /f "tokens=17,17 delims=, " %%a in ("%res%") do (
   @set data9=%%a
)
@for /f "tokens=18,18 delims=, " %%a in ("%res%") do (
   @set data10=%%a
)
@for /f "tokens=19,19 delims=, " %%a in ("%res%") do (
   @set data11=%%a
)
@for /f "tokens=20,20 delims=, " %%a in ("%res%") do (
   @set data12=%%a
)
@for /f "tokens=21,21 delims=, " %%a in ("%res%") do (
   @set data13=%%a
)

@echo -------------------------------
@set SN=%data0%%data1%%data2%%data3%%data4%%data5%%data6%%data7%%data8%%data9%%data10%%data11%
@setlocal enabledelayedexpansion
@echo Serial Number(Hex): !SN!
@echo !SN!> temp.hex
@call certutil -decodehex temp.hex str.txt >nul
@set /p str=<str.txt
@( del temp.hex & del str.txt )>nul
@echo Serial Number(Str): !str!
@endlocal


if %SN% == ffffffffffffffffffffffff (
    @goto SET_SERIAL_NUMBER
)

if %SN% == 000000000000000000000000 (
    @goto SET_SERIAL_NUMBER
)
@goto RF_GEN


:SET_SERIAL_NUMBER
@echo --------------------- Factory Mode - Set Serial Number ---------------------

@set RES=
@set STR=4155544F50414952494E4721

SETLOCAL ENABLEDELAYEDEXPANSION
REM Split STR by N characters
SET "N=2"
:LOOP1
SET "RES=%RES%!STR:~0,%N%! "
SET "STR=!STR:~%N%!"
IF DEFINED STR GOTO LOOP1
@ECHO %RES:~0,-1%

REM                   PID                          | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%   FA    0E    00 00   %RES:~0,-1%
@goto RF_GEN


rem :SET_DNG_ISN
rem @echo --------------------- Factory Mode - Set Serial Number to dongle ---------------------
rem @set RES=
rem @set STR=%SN%
rem 
rem SETLOCAL ENABLEDELAYEDEXPANSION
rem REM Split STR by N characters
rem SET "N=2"
rem :LOOP2
rem SET "RES=%RES%!STR:~0,%N%! "
rem SET "STR=!STR:~%N%!"
rem IF DEFINED STR GOTO LOOP2
rem @ECHO %RES:~0,-1%
rem REM                   PID                          | CMD | Key | Index  | Data...
rem usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%   FA    0E    00 00   %RES:~0,-1%
rem @goto RF_GEN


:RF_GEN
@echo --------------------- Factory Mode - Generate RF Pairing data by dongle -----------------
for /f %%# in ('wMIC Path Win32_LocalTime Get /Format:value') do @for /f %%@ in ("%%#") do @set %%@
SET Year1=%Year:~0,2%
SET Year2=%Year:~2,2%
echo %Year1% %Year2% %Month% %Day% %Hour% %Minute% %Second%

REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    20    01 00    47  45  4E  45  52  41  54  45  %Year1%  %Year2%  %Month%  %Day%  %Hour%  %Minute%  %Second%


@echo --------------------- Factory Mode - Read Pairing data by dongle ------------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    20    02 00    52  45  41  44 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto ERROR
@type temp.txt | findstr /n /c:"hid read" > dongle_pairing_info.txt
@del temp.txt
@echo  -Read dongle pairing data.

::@set /p dev_pi=<%DEVICE_NAME%_pairing_info.txt
::::@set /p dev_bpi=<%DEVICE_NAME%_before_pairing_info.txt
::
::@set m_ch="%dev_pi:~28,30%"
::@set mb_ch="%dev_bpi:~28,30%"
::if %m_ch% == %mb_ch% (
::	color 0E
::	@echo read channel %m_ch% is the same %mb_ch%, regenerate !
::	@goto RE_GEN
::)


color 07
@echo --------------------- Factory Mode - Write Pairing data to device -----------------------
@set /p res=<dongle_pairing_info.txt
@set substr=%res:~25,101%
@set rmp=%substr:,= %
@echo read %DEVICE_NAME% pairing info: %rmp%
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    20    03 00    57  52  49  54  45  %rmp%
@echo  -Write pairing data to device.


@echo --------------------- Factory Mode - Read Pairing data by device ------------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    20    02 00    52  45  41  44 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto ERROR
@type temp.txt | findstr /n /c:"hid read" > %DEVICE_NAME%_pairing_info.txt
@del temp.txt
@set /p dongle_pi=<dongle_pairing_info.txt
@set /p dev_pi=<%DEVICE_NAME%_pairing_info.txt

::@set d_ch="%dongle_pi:~28,30%"
::@set m_ch="%dev_pi:~28,30%"
::if not %d_ch% == %m_ch% (
::	@echo read channel %d_ch% fail, please rewrite pairing data again !
::	@goto FAIL
::)
::
::@set d_sw[0]=%dongle_pi:~58,2%
::@set d_sw[1]=%dongle_pi:~61,2%
::@set d_sw[2]=%dongle_pi:~64,2%
::@set d_sw[3]=%dongle_pi:~67,2%
::@set m_sw[0]=%dev_pi:~58,2%
::@set m_sw[1]=%dev_pi:~61,2%
::@set m_sw[2]=%dev_pi:~64,2%
::@set m_sw[3]=%dev_pi:~67,2%
::
::if %d_sw[0]% NEQ %m_sw[0]% (
::	@echo read syncword0 %d_sw[0]% fail, please rewrite pairing data again !
::	@goto FAIL
::)
::if %d_sw[1]% NEQ %m_sw[1]% (
::	@echo read syncword1 %d_sw[1]% fail, please rewrite pairing data again !
::	@goto FAIL
::)
::if %d_sw[2]% NEQ %m_sw[2]% (
::	@echo read syncword2 %d_sw[2]% fail, please rewrite pairing data again !
::	@goto FAIL
::)
::if %d_sw[3]% NEQ %m_sw[3]% (
::	@echo read syncword3 %d_sw[3]% fail, please rewrite pairing data again !
::	@goto FAIL
::)
::
::@set d_addr=%dongle_pi:~70,2%
::@set m_addr=%dev_pi:~70,2%
::if %d_addr% NEQ %m_addr% (
::	@echo read address %d_addr% fail, please rewrite pairing data again !
::	@goto FAIL
::)
::
::@echo Read Dongle pairing info pass !
::@del dongle_pairing_info.txt
::@del mouse_pairing_info.txt

@echo --------------------- Factory Mode - Device Force Enter Factory Mode -----------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    20    04 00    45  4E  5F  52  46
@echo  -Device Force Enter RF Mode.


timeout /t 3
@echo --------------------- Factory Mode - RF connect check ------------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DEVICE_USAGE_PAGE%    FA    20    06 00    56  45  52  49  46  59 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto ERROR
@type temp.txt | findstr /n /c:"hid read" > temp2.txt
@del temp.txt
@set /p res=<temp2.txt && del temp2.txt

@for /f "tokens=8,8 delims=, " %%a in ("%res%") do (
   @set data0=%%a
)
if %data0% == 01 (
	color 02
	@echo connect pass !
) else (
	color 04
	@echo connect fail !
)


@echo --------------------- Factory Mode - Device Force Leave Factory Mode -----------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    20    05 00    4C  56  5F  52  46
@echo  -Device Force Leave RF Mode.


timeout /t 3
goto EXIT
@echo --------------------- Factory Mode - Disable Factory Mode --------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%     FA    00    00 00    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Disable %DEVICE_NAME% Factory Mode.

REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    00    00 00    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Disable Dongle Factory Mode.
exit /b 1
rem goto RETRY


:FAC_ERROR
color 04
@echo Enable Factory Mode Fail
exit /b 1
rem goto RETRY

:FAIL
color 04
@echo fail
exit /b 1
rem @PAUSE
rem goto RETRY

:ERROR
color 04
@echo  -No device!
@del temp.txt
exit /b 1
rem @PAUSE
rem goto RETRY

:EXIT
@echo --------------------- Factory Mode - Disable Factory Mode ---------------------
REM               PID                                | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%     FA    00    00 00    00
@echo  -Disable %DEVICE_NAME% Factory Mode.

REM               PID                                | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%     FA    00    00 00    00
@echo  -Disable Dongle Factory Mode.

@set M=
@set data0=
@echo on
